#line 1 "P:/_Electronique_/# LibStock #/# Display temperature on mini web server - 18F4620  8MHz - ENC28J60 - DS18s20 #/PIC18F4620_a_8MHz_ENC28J60_DS18s20.c"
#line 1 "p:/_electronique_/# libstock #/# display temperature on mini web server - 18f4620  8mhz - enc28j60 - ds18s20 #/mikroc.h"


void Display_Version_UART()
{

 UART1_Write_Text( "MikroC v6.0.0" " - ");
 UART1_Write_Text( "Apr 27 2013" " - ");
 UART1_Write_Text( "15:55:52" "\r");
}
#line 1 "p:/_electronique_/# libstock #/# display temperature on mini web server - 18f4620  8mhz - enc28j60 - ds18s20 #/lib_1wire_ds18s20.h"


float temperature_DS18s20;




void Reading_Temperature_DS18s20(void)
{
 unsigned int temp_;
 unsigned int temp_DS18s20;
 float T_DS18s20;





 Ow_Reset(& PORTE ,  0 );
 Ow_Write(& PORTE ,  0 , 0xCC);
 Ow_Write(& PORTE ,  0 , 0x44);

 Delay_us(600);
 Ow_Reset(& PORTE ,  0 );
 Ow_Write(& PORTE ,  0 , 0xCC);
 Ow_Write(& PORTE ,  0 , 0xBE);

 temp_ = Ow_Read(& PORTE ,  0 );
 temp_DS18s20 = (Ow_Read(& PORTE ,  0 ) << 8) + temp_;


 if(temp_DS18s20 & 0x8000)
 {
 temp_DS18s20 = ~temp_DS18s20 + 1;
 T_DS18s20 = -((float)temp_DS18s20);
 }
 else
 {
 T_DS18s20 = (float)temp_DS18s20;
 }

 T_DS18s20 = 0.5 * T_DS18s20;
 temperature_DS18s20 = T_DS18s20;
}
#line 40 "P:/_Electronique_/# LibStock #/# Display temperature on mini web server - 18F4620  8MHz - ENC28J60 - DS18s20 #/PIC18F4620_a_8MHz_ENC28J60_DS18s20.c"
void Mesure()
{
 Reading_Temperature_DS18s20();

}

char uart_rd;
char buffer[32];

void Display_UART()
{
 char T_buffer[15];

 FloatToStr(temperature_DS18s20, T_buffer);

 UART1_Write_Text(T_buffer);
 UART1_Write_Text("'C\r");
}

sbit SPI_Ethernet_Rst at RC0_bit;
sbit SPI_Ethernet_CS at RC1_bit;

sbit SPI_Ethernet_Rst_Direction at TRISC0_bit;
sbit SPI_Ethernet_CS_Direction at TRISC1_bit;
#line 76 "P:/_Electronique_/# LibStock #/# Display temperature on mini web server - 18F4620  8MHz - ENC28J60 - DS18s20 #/PIC18F4620_a_8MHz_ENC28J60_DS18s20.c"
const unsigned short TEMP_RESOLUTION = 12;
char *text = "000,0";


const unsigned char httpHeader[] = "HTTP/1.1 200 OK\nContent-type: " ;
const unsigned char httpMimeTypeHTML[] = "text/html\n\n" ;
const unsigned char httpMimeTypeScript[] = "text/plain\n\n" ;
unsigned char httpMethod[] = "GET /";
#line 101 "P:/_Electronique_/# LibStock #/# Display temperature on mini web server - 18F4620  8MHz - ENC28J60 - DS18s20 #/PIC18F4620_a_8MHz_ENC28J60_DS18s20.c"
const char *indexPage = "<meta http-equiv='refresh' content='10;url=http://192.168.0.170/'><HTML><HEAD><title>ENC28J60 & PIC18F4620 & DS18s20</title></HEAD><BODY><center>WEB Server designed for PIC18F4620, ENC28J60 and DS18s20,<p><p>avec "  "MikroC v6.0.0"  "<p>Compilation  "  "15:55:52"  " le "  "Apr 27 2013" "<p></center><hr size=2 align=center width=60%><center><a href=/>REFRESH</a></center><script src=/s></script><p>&nbsp;</p><hr size=2><center>TEMPERATURE: <h1><script>document.write(T_)</script>C</h1></center><p><p>&nbsp;</p><p>&nbsp;</p><p>&nbsp;</p>This is HTTP request=<script>document.write(REQ)</script></BODY></HTML>" ;
#line 106 "P:/_Electronique_/# LibStock #/# Display temperature on mini web server - 18F4620  8MHz - ENC28J60 - DS18s20 #/PIC18F4620_a_8MHz_ENC28J60_DS18s20.c"
unsigned char myMacAddr[6] = {0x00, 0x14, 0xA5, 0x76, 0x19, 0x3f} ;
unsigned char myIpAddr[4] = {192, 168, 0, 170} ;
unsigned char getRequest[15] ;
unsigned char dyna[31] ;
unsigned long httpCounter = 0 ;
#line 160 "P:/_Electronique_/# LibStock #/# Display temperature on mini web server - 18F4620  8MHz - ENC28J60 - DS18s20 #/PIC18F4620_a_8MHz_ENC28J60_DS18s20.c"
unsigned int SPI_Ethernet_UserTCP(unsigned char *remoteHost, unsigned int remotePort,
 unsigned int localPort, unsigned int reqLength, char *canClose)
 {
 unsigned int len = 0 ;
 unsigned int i ;

 if(localPort != 80)
 {
 return(0) ;
 }


 for(i = 0 ; i < 10 ; i++)
 {
 getRequest[i] = SPI_Ethernet_getByte() ;
 }
 getRequest[i] = 0 ;

 if(memcmp(getRequest, httpMethod, 5))
 {
 return(0) ;
 }

 httpCounter++ ;

 if(getRequest[5] == 's')
 {
 Display_UART();



 len =  SPI_Ethernet_putConstString (httpHeader) ;
 len +=  SPI_Ethernet_putConstString (httpMimeTypeScript) ;


 len +=  SPI_Ethernet_putConstString ("T_=");
 FloatToStr(temperature_DS18s20, dyna);

 len +=  SPI_Ethernet_putString (dyna);
 len +=  SPI_Ethernet_putConstString ("; ");


 IntToStr(httpCounter, dyna) ;
 len +=  SPI_Ethernet_putConstString ("var REQ=") ;
 len +=  SPI_Ethernet_putString (dyna) ;
 len +=  SPI_Ethernet_putConstString (";") ;
 }

 if(len == 0)
 {
 len =  SPI_Ethernet_putConstString (httpHeader) ;
 len +=  SPI_Ethernet_putConstString (httpMimeTypeHTML) ;
 len +=  SPI_Ethernet_putConstString (indexPage) ;
 }

 return(len) ;
 }
#line 228 "P:/_Electronique_/# LibStock #/# Display temperature on mini web server - 18F4620  8MHz - ENC28J60 - DS18s20 #/PIC18F4620_a_8MHz_ENC28J60_DS18s20.c"
unsigned int SPI_Ethernet_UserUDP(unsigned char *remoteHost, unsigned int remotePort,
 unsigned int localPort, unsigned int reqLength, char *canClose)
 {
 return 0 ;
 }
#line 238 "P:/_Electronique_/# LibStock #/# Display temperature on mini web server - 18F4620  8MHz - ENC28J60 - DS18s20 #/PIC18F4620_a_8MHz_ENC28J60_DS18s20.c"
void main()
{
 CMCON |=7;
 ADCON0= 0;
 ADCON1 = 0x0F ;
 ADCON2 = 0x40;

 PORTA = 0 ;
 TRISA0_bit = 1;

 PORTB = 0 ;
 TRISB = 0xff ;

 PORTA = 0;
 TRISA = 0x01;

 Reading_Temperature_DS18s20();
 Delay_ms(1000);
 Reading_Temperature_DS18s20();

 UART1_Init(57600);
 Delay_ms(100);

 Display_Version_UART();
#line 270 "P:/_Electronique_/# LibStock #/# Display temperature on mini web server - 18F4620  8MHz - ENC28J60 - DS18s20 #/PIC18F4620_a_8MHz_ENC28J60_DS18s20.c"
 SPI1_Init();
 SPI_Ethernet_Init(myMacAddr, myIpAddr,  1 );

 while(1)
 {
 SPI_Ethernet_doPacket() ;

 Mesure();

 Display_UART();

 Reading_Temperature_DS18s20();
#line 287 "P:/_Electronique_/# LibStock #/# Display temperature on mini web server - 18F4620  8MHz - ENC28J60 - DS18s20 #/PIC18F4620_a_8MHz_ENC28J60_DS18s20.c"
 }
 }
